function rj=HCNSresiduals(H0,gcoxhat,xcen,status,defineevent,Z)

linp=0;
for i=1:length(gcoxhat)
    linp=linp+(Z(:,i).*gcoxhat(i));
end
    

rj=H0(xcen).*exp(linp);


[~, Hr, ~, ~, ~]=HCNS(rj, status ,defineevent, [], 'auto', 2,[], 'cumulative hazard');


plot(sort(rj),Hr(sort(rj)),'o-r','LineWidth',2)
xlabel('r_i')
ylabel('HCNS at r_i')
%title('HCNS based cox-snell-type residuals')
hold on
gr0=linspace(0,max(rj),500);
plot(gr0,gr0,'--k','LineWidth',2)
end